local require = GLOBAL.require
require "prefabutil"
require "class"
local containers = require "containers"
local cooking = require "cooking"

local new_slotpos = {
    --Vanilla
    GLOBAL.Vector3(0, 65+64 + 32 + 8 + 4, 0),
    GLOBAL.Vector3(0, 65+32 + 4, 0),
    GLOBAL.Vector3(0, 65-(32 + 4), 0),
    GLOBAL.Vector3(0, 65-(64 + 32 + 8 + 4), 0),
}

local utilslotpos = {
    GLOBAL.Vector3(0, 65-(72+64 + 32 + 8 + 4), 0),
}

local new_cookpos = GLOBAL.Vector3(0, -240, 0)

local predict_button = {
    text = "Predict!",
    position = GLOBAL.Vector3(-0, -185, 0),
    fn = function(inst)
        action = GLOBAL.ACTIONS.PREDICT
        if inst.components.container ~= nil then
            GLOBAL.BufferedAction(inst.components.container.opener, inst, action):Do()
        elseif inst.replica.container ~= nil and not inst.replica.container:IsBusy() then
            inst.components.predicter:Predict()
        end
    end,
}

containers.smartercrockpot_old_widgetsetup=containers.widgetsetup

function containers.widgetsetup(container, prefab, data)
    containers.smartercrockpot_old_widgetsetup(container, prefab, data)

    target = prefab or container.inst.prefab
    if target == "cookpot" or target == "portablecookpot" then
      container.widget.slotpos = new_slotpos
      container.widget.utilslotpos = utilslotpos

      container.widget.buttoninfo.position = new_cookpos

      container.widget.buttoninfo2 = predict_button
      container.widget.buttoninfo2.validfn = container.widget.buttoninfo.validfn -- copy in validfn at runtime
    end

end
